//
//  UITextView+RACSignalSupport.h
//  ReactiveCocoa
//
//  Created by Cody Krieger on 5/18/12.
//  Copyright (c) 2012 Cody Krieger. All rights reserved.
//

#import <UIKit/UIKit.h>

@protocol RACSignal;

@interface UITextView (RACSignalSupport)

// Creates and returns a signal that sends the sender of the delegate method
// whenever it is triggered.
- (id<RACSignal>)rac_signalForDelegateMethod:(SEL)method;

// Creates and returns a signal for the text of the field. It always starts with
// the current text.
- (id<RACSignal>)rac_textSignal;

@end
